#include "config.h"


#include <fstream>;
using namespace std;

config config::cfg;
config& cfg = config::instance();

void config::setup() {
	ifstream in("./config.cfg");

	int word = 0;
	string val;
	int in_i;
	double in_d;
	while(in.good()) {
		if (val == "numTrees") {
			in >> in_i;
			configure::numTrees = in_i;
			cout << val << " changed to " << in_i << endl;
		}
		else if (val == "numBirds") {
			in >> in_i;
			configure::numBirds = in_i;
			cout << val << " changed to " << in_i << endl;
		}
		else if(val == "numGraves") {
			in >> in_i;
			configure::numGraves = in_i;
			cout << val << " changed to " << in_i << endl;
		}
		else if (val == "burstCount") {
			in >> in_i;
			fireworks_config::burstCount = in_i;
			cout << val << " changed to " << in_i << endl;
		}
		else
			cout << "unrecognized entry" << val << endl;
		in >> val;
	}
	
	cout << "end config" << endl;
}

namespace configure {
	int numTrees = 18, numBirds = 50, numGraves = 80;
}

namespace fireworks_config {
	double speedMult = 0.075;
	double grav = 0.002;
	double pSize = 5;

	double terminal = -5;
	double decay = 0.0004;
	double rocketBurstSpeed = -0.2;
	double rocketTime = 3000;
	double maxRockets = 5;
	int burstCount = 3000;
	double rocketSpeed = 1.4;
	int rocketTrail = 2;
}

namespace tree_config {
	namespace trees {
		double medScale = 3;
		double maxScaleChange = 1;
		double scalePower = 2;
		int count = 10;
	}
	namespace limbs {
		double startLength = 10;
		double lengthMin = 0.5;
		double lengthMax = 0.6;
		double downMin = 30;
		double downMax = 70;
		int split = 3;
		double angleVariance = 0.7;
		double ratio = 0.085;
		double endLength = 0.0001;
		double branchMin = 0.1;
		int maxDepth = 1;
		int count = 20;
	}

	namespace bases {
		double startLength = 20;
		double lengthMin = 0.7;
		double lengthMax = 0.8;
		double downMin = 25;
		double downMax = 60;
		int split = 3;
		double angleVariance = 0.8;
		double ratio = 0.1;
		double endLength = 10;
		double branchMin = 0.8;
		int maxDepth = 1;
		int count = 8;
	}

}

namespace bird_config {
	float minz = 140;
	float maxz = 170;
	float meMult = 0.8, avoidMult = 0.08, crowdMult = 0.05, copyMult = 0.07;
}
	

