#pragma once
#include "grobject.h"
#include "global.h"

class fireworks :
	public GrObject
{
	long last;
	long lastRocket;
	bool night;

	float x, y, z;

	
public:
	struct particle {
		float x, y, z, dx, dy, dz, r, g, b, size;
		particle(Color, triple, triple);
		void draw();
		bool update(long);
	};

	struct rocket {
		vector<particle>* particles;
		float x, y, z, dx, dy, dz, r, g, b, size;
		rocket(Color, triple, triple, vector<particle>*);
		void draw();
		bool update(long);
	};

private:
	vector<particle> particles;
	vector<rocket> rockets;

public:
	fireworks(float, float, float);
	~fireworks(void);

	void burst(float, float, float);

	virtual void draw(DrawingState*);
	virtual void simulateUntil(unsigned long time);
};

typedef fireworks::particle particle;
