#pragma once

#pragma warning(disable:4305)
#pragma warning(disable:4312)
#pragma warning(disable:4311)


#include <vector>
#include <iostream>
#include <map>
#include <string>
#include <strstream>
#include <cmath>
#include <algorithm>

#include "gl.h"

#include <GL/glu.h>
#include <FL/glut.h>

#include "DrawUtils.h"

#include "RC/point.h"
#include "config.h"


using namespace std;

void gl_rotate(triple, triple, triple);
void glCube(float);
void glCylinder(float);
void glSphere(float);
void square(float, float, int, string name);
void csquare(float, float, int, float, float, float, float);

struct region {
	double x1, z1, x2, z2;
	region(double a, double b, double c, double d) : x1(a), z1(b), x2(c), z2(d) {}
	bool in(double x,double z) {
		return (z1 < z2 ? z > z1 && z < z2 : z > z2 && z < z1) && (x1 < x2 ? x > x1 && x < x2 : x > x2 && x < x1);
	}
};

enum {
	UP_Z,
	DOWN_Z,
	UP_Y,
	DOWN_Y,
	UP_X,
	DOWN_X
};


inline double drand(double min, double max) {return min + (max - min) * (1.0 * rand() / RAND_MAX);}
inline int irand(int min, int max) {return min + ((max - min + 1) * drand(0, 0.9999));}
