#pragma once
#include "grobject.h"
#include "global.h"
#include "depthSorter.h"

class widow :
	public special
{
	std::vector<region>* regions;
	int state;
	int widowtime;
	float step;
	int dstep;
	unsigned long last;
	enum states {
		COMING,
		GOING,
		KNEELING,
		TO_KNEELING,
		FROM_KNEELING,
		PLACING_ROSE,
		DONE_PLACING_ROSE,
		STANDING,
	};
	float x, z;
	float tx, tz;
	float dx, dz;
	float fade;
public:
	widow(std::vector<region>*);
	~widow(void);

	virtual void drawSpecial(DrawingState*);
	virtual void simulateUntil(unsigned long time);

	float xv() {return x;}
	float zv() {return z;}
};
