#pragma once
#include "grobject.h"

#include "global.h"
using namespace std;



class bird :
	public GrObject
{
	static vector<bird*> flock;
	static string name;
	static int count;

	double angle1;
	double size;

	float dx, dy, dz;

	float x, y, z;

	unsigned long last;

public:
	bird(double s, float a = 0, float idx = 1, float idy = -1, float ix = 0, float iy = 0) 
		: GrObject("bird"), 
		  size(s), 
		  angle1(a),
		  dx(idx),
		  dy(idy),
		  x(ix),
		  y(iy),
		  last(0)
	{
		z = drand(bird_config::minz, bird_config::maxz);
		dz = drand(-0.1, 0.1);
		flock.push_back(this); 
		x = -1000 + rand() % 2000; 
		y =-1000 +  rand() % 2000; 
		dx -= 2.0 * rand() / RAND_MAX; 
		dy += 2.0 * rand() / RAND_MAX; 
		angle1 = rand() & 1 ? -40 + rand() % 80 : 140 + rand() % 80;
		name = "bird" + count++;
	}

	virtual void draw(DrawingState*);
	virtual void simulateUntil(unsigned long time);
};
