#pragma once
#include "grobject.h"
#include "global.h"

class tree :
	public GrObject
{
	
	int id;
	int x, y;
	float r, g, b;
	tree(void);
	~tree(void);

	static int limbs[20];
	static int bases[8];
	static vector<vector<float*> > baseEnds;
	static int trees[20];

	static void makeBase(double, int, vector<float*>&);
	static void makeLimb(double, int);
	static void make();
	static void draw(int);
	static void drawLeaf();
public:
	virtual void draw(DrawingState*) {	glColor3f(r, g, b); glTranslatef(x, 0, y); draw(id);}
	static tree* generate(int = 0, int = 0);

};
